
// STRUMPAD ARDUINO 1.2 (using piezo sensor) AUG 13 2018
// ATmega328P microcontroller with optiboot_atmeg328-Mini bootloader . Arduino Mini board chosen from Arduino Tools menu.
// If Arduino Mini board in Arduino Tools then try also Arduino Mini Pro board.
//
// Imroving the Strumpad piezo sensing
// Added Mute all string when all strings touched
// Added Reset all and note off to all notes on channel 1-6
// Added Toggle Right Left Hand playing when string 6 touched for few secs.
// Added Toggle Octave doubling when string 1 touched for few secs.
// StrumPad listens for midi notes in a range from note 21 to 108 (A0 to C8)
// IMPORTANT, DON'T TOUCH THE STRUMPAD DURING POWER UP, IT IS CALIBRATIONG THE STRING TOUCH SENSORS! IF TOUCHED DURING POWER UP, THE STRING WILL NOT BE RESPONSIVE TO TOUCH.
//
// Added Handle for ProgramChange; Program Change midi messages will pass through StrumPad
// Added Handle for AfterTouchChannel; Aftertouch Channel messages will pass through StrumPad
// Added Handle for PitchBend; PitchBend messages will pass through StrumPad
// Hande for Control Change messages exist already; all CC messages will pass through StrumPad

// STRUMPAD ARDUINO 1.1 (using piezo sensor) FEB 4 2016
// https://youtu.be/M27RP-gmd5Y (showing Strumpad with Load sensor)
// A guitar for a keyboard player!
// Created by: Miroslaw Sowa
// Date: Jan 3, 2016
// added; sending midi on different channels, each string has its channel; string 1 channel 1, string 2 channel 2...

// Arduino sketch, modified MIDI library and schematics link;
// https://www.dropbox.com/s/buldx9tq2e7xhr4/STRUMPAD%20with%20schematics%20and%20Arduino%20Libraries.zip?dl=0

// ALWAYS disconnect MIDI IN and MIDI OUT in order to upload sketch cause MIDI messages are on the same serial RX and TX pins!
// CAPSENSE might needs real ground, it might not work if powered from Laptop or battery for example.

// This program takes midi data from keyboard and by strumming the STRUMPAD will output midi data. It's a MIDI guitar for a KEYBOARD player.
// STRUMPAD has 6 capacitive 'string' sensors and a piezo input sensorunder it for MIDI velocity calculation. Leds show the active strings.
// The first 3 notes are doubled (octave higher) for richer sound just using 3 fingers :)

// in order for MIDI to work properly I had to modify the MIDI library version 3.2 (modified***) so please used the attached MIDI library
// this program was made and tested with Arduino 1.6.7 on mac computer running OS 10.10.5

// *** had to change the MIDI.h library file and switched the note on and note off values cause the handlenoteoff callback did not want to work! ***
// *** in the MIDI.h library files, the values for Note On and Note Off were inverted by me the 0x80 is now 0x90 and vice versa ***

// Need to add code so when pressing and releasing 2 or more string they all sound when released not only 1 string.

// this sketch is using Fastest digitalRead / digitalWrite Alternative;
/*
  pinMode( pin, INPUT ); replaced with pinAsInput( pin );
  pinMode( pin, OUTPUT ); replaced with pinAsOutput( pin );
  pinMode( pin, INPUT_PULLUP); replaced with pinAsInputPullUp( pin );
  digitalWrite( pin, LOW ); replaced with digitalLow( pin );
  digitalWrite( pin, HIGH ); replaced with digitalHigh( pin );
  digitalRead( pin ) replaced with digitalState( pin )
*/
#define portOfPin(P)\
  (((P)>=0&&(P)<8)?&PORTD:(((P)>7&&(P)<14)?&PORTB:&PORTC))
#define ddrOfPin(P)\
  (((P)>=0&&(P)<8)?&DDRD:(((P)>7&&(P)<14)?&DDRB:&DDRC))
#define pinOfPin(P)\
  (((P)>=0&&(P)<8)?&PIND:(((P)>7&&(P)<14)?&PINB:&PINC))
#define pinIndex(P)((uint8_t)(P>13?P-14:P&7))
#define pinMask(P)((uint8_t)(1<<pinIndex(P)))

#define pinAsInput(P) *(ddrOfPin(P))&=~pinMask(P)
#define pinAsInputPullUp(P) *(ddrOfPin(P))&=~pinMask(P);digitalHigh(P)
#define pinAsOutput(P) *(ddrOfPin(P))|=pinMask(P)
#define digitalLow(P) *(portOfPin(P))&=~pinMask(P)
#define digitalHigh(P) *(portOfPin(P))|=pinMask(P)
#define isHigh(P)((*(pinOfPin(P))& pinMask(P))>0)
#define isLow(P)((*(pinOfPin(P))& pinMask(P))==0)
#define digitalState(P)((uint8_t)isHigh(P))

#define FASTADC 1 // Fast AnalogRead in order to shorten the reading time of the Analog Input //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL
#ifndef cbi  // defines for setting and clearing register bits
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif           // Fast AnalogRead in order to shorten the reading time of the Analog Input

// ************************************************************ //readCapacitivePin ******************************************************************************************
//  readCapacitivePin = 10   ...a capacitor of 1nF is recommended in line with the pin to decouple 50Hz noises (I guess its for Europe).
//  Input: Arduino pin number
//  Output: A number, from 0 to 17 expressing
//  how much capacitance is on the pin
//  When you touch the pin, or whatever you have
//  attached to it, the number will get higher

uint8_t readCapacitivePin(int pinToMeasure) {
  // Variables used to translate from Arduino to AVR pin naming
  volatile uint8_t* port;
  volatile uint8_t* ddr;
  volatile uint8_t* pin;
  //  Here we translate the input pin number from
  //  Arduino pin number to the AVR PORT, PIN, DDR,
  //  and which bit of those registers we care about.
  byte bitmask;
  if ((pinToMeasure >= 0) && (pinToMeasure <= 7)) {
    port = &PORTD;
    ddr = &DDRD;
    bitmask = 1 << pinToMeasure;
    pin = &PIND;
  }
  if ((pinToMeasure > 7) && (pinToMeasure <= 13)) {
    port = &PORTB;
    ddr = &DDRB;
    bitmask = 1 << (pinToMeasure - 8);
    pin = &PINB;
  }
  if ((pinToMeasure > 13) && (pinToMeasure <= 19)) {
    port = &PORTC;
    ddr = &DDRC;
    bitmask = 1 << (pinToMeasure - 13);
    pin = &PINC;
  }
  // Discharge the pin first by setting it low and output
  *port &= ~(bitmask);
  *ddr  |= bitmask;
  delay(1);
  // Make the pin an input with the internal pull-up on
  *ddr &= ~(bitmask);
  *port |= bitmask;
  // Now see how long the pin to get pulled up
  int cycles = 17;
  for (int i = 0; i < 16; i++) {
    if (*pin & bitmask) {
      cycles = i;
      break;
    }
  }
  //  Discharge the pin again by setting it low and output
  //  It's important to leave the pins low if you want to
  //  be able to touch more than 1 sensor at a time - if
  //  the sensor is left pulled high, when you touch
  //  two sensors, your body will transfer the charge between
  //  sensors.
  *port &= ~(bitmask);
  *ddr  |= bitmask;

  return cycles;
}
int ditcapPin = 10;  // pin for capacitive sensing using this new code


// ************************************************************ LIBRARIES & DEFINED ******************************************************************************************
// MIDI
// CAPSENSE (STRINGS)
// LEDS
// PIEZO (FOR VELOCITY)

#include <MIDI.h>  // Add Midi Library *** midi_Defs.h (MIDI library used is version 3.2 modified by me, see above)

#include <CapacitiveSensor.h> //capacitive sensor library

# define capsense_touched_value 100 // 50 initially, value of the capsense sensor when touched   //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL

# define piezo_max 100 // (original:85) Value of PIEZO when activated to the max (known value after testing)  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL
# define piezo_input A1 // analog input for PIEZO
# define piezo_treshold 1 // added value to PIEZO to detect activation

// ************************************************************ VARIABLES ****************************************************************************************************
// MIDI
// CAPSENSE (STRINGS)
// LEDS
// PIEZO (FOR VELOCITY)

// MIDI
byte note_on_Array[127]; //array has the same address as pitch, if note on that pitch value is 1, if note off that pitch value is 0
byte string_Array[6]; //array with string note values for each string from 0-5; stings 1-6. This array has only 6 elements => string_Array[6] is not in the array!
byte note_on_count = 0; // variable for string_Array 0 to 5 to load temporary NoteOn values
byte midi_channel = 0; // variables for midi out messages
int  midi_velocity = 0; // MIDI velocity of the MIDI note mapped from the PIEZO data
int  midi_velocity_max = 0;
byte midi_velocity_zero = 0;
byte midi_channel_listen = 1; // on what channel to listen for midi data
byte octave_doubling = 1; // will double octave for up to 3 bottom notes (default). This can be deactivated by holding string 1 (string0) for few seconds until there are 3 led flashes.

// CAPSENSE (STRINGS)  // experiment with different resistor values
CapacitiveSensor string_1 = CapacitiveSensor(4, 2);       // 2.2 megohm resistor between pins 4 & 2, pin 2 is sensor pin, add wire, foil
CapacitiveSensor string_2 = CapacitiveSensor(4, 3);       // 2.2 megohm resistor between pins 4 & 3, pin 3 is sensor pin, add wire, foil
CapacitiveSensor string_3 = CapacitiveSensor(4, 5);       // 2.2 megohm resistor between pins 4 & 5, pin 5 is sensor pin, add wire, foil
CapacitiveSensor string_4 = CapacitiveSensor(4, 6);       // 2.2 megohm resistor between pins 4 & 6, pin 6 is sensor pin, add wire, foil
CapacitiveSensor string_5 = CapacitiveSensor(4, 7);       // 2.2 megohm resistor between pins 4 & 7, pin 7 is sensor pin, add wire, foil
CapacitiveSensor string_6 = CapacitiveSensor(4, 8);       // 2.2 megohm resistor between pins 4 & 8, pin 8 is sensor pin, add wire, foil

long string_total_array [6]; // array holding all the strings sensor values
int  string_touched [6]; // telling when strings are being touched
int  string_just_touched [6]; // telling when strings were touched
int  string_just_released [6];  // telling when strings were just released
byte string_touched_byte = B00000000; // byte variable to hold the touched strings ex. B00000011 tells us that String0 and String1 are touched.
byte reset_timer_started = 0; // flag when we start the reset timer (hold string 1&6 for few seconds and the Strumpad will send midi reset messages.
byte timer_started = 0; // timer flag when starting reset timer (touching string 1 and 6 for set time period will reset all)
long start_timer = 0; //timer when starting reset timer (touching string 1 and 6 for set time period will reset all)
byte timer_started_2 = 0; // timer flag when starting reset timer ( hold string 6 for few sesonds and StrumPad will become playable for Left Handed player )
long start_timer_2 = 0; // timer flag when starting reset timer ( hold string 6 for few sesonds and StrumPad will become playable for Left Handed player )
byte timer_started_3 = 0; // used to keep the midi velocity value for few hundred milliseconds when not touching the strings
long start_timer_3 = 0; // used to keep the midi velocity value for few hundred milliseconds when not touching the strings
bool Left_Hand = 0; // flag for Left Hand
byte timer0_started = 0; // timer for Aftertouch
long start_timer0 = 0; // timer for Aftertouch

// LEDS and LARSON SCANNER
byte led_string_Array [6] = { 9, 14, 16, 17, 18, 19 }; // A0 = 14, A2 = 16 (depends what atmega is being used, see documentation on arduino site)
int  delay_leds = 25; // Delay to determine when we see the next LED

// PIEZO (FOR VELOCITY)
int  piezo_value = 0; // sensor value from ADC
int  piezo_calibration = 0;  // value of PIEZO when activated
int  piezo_high = 0; // highest value of PIEZO when activated
int  piezo_flag = 0; // to reset the highest value after deactivationg PIEZO

// FOR DEBUG
byte midi_channel_debug = 0;   // for DEBUG
byte control_number_debug = 0; // for DEBUG
byte control_value_debug = 0;  // for DEBUG

void setup() { // ***********************************************************************************************************************************************************
  // *************************************************************************************** SETUP **************************************************************************
  // ************************************************************************************************************************************************************************
  // MIDI
  // CAPSENSE (STRINGS)
  // LEDS
  // PIEZO (FOR VELOCITY)

  // FOR DEBUG FOR DEBUG FOR DEBUG FOR DEBUG FOR DEBUG FOR DEBUG FOR DEBUG FOR DEBUG
  //DDRB = DDRB | B00000100; // sets port PB2 as output  // remove after debugging


#if FASTADC  // Fast AnalogRead in order to shorten the reading time of the Analog Input
  sbi(ADCSRA, ADPS2) ; // set prescale to 16
  cbi(ADCSRA, ADPS1) ; // set prescale to 16
  cbi(ADCSRA, ADPS0) ; // set prescale to 16
#endif      // Fast AnalogRead in order to shorten the reading time of the Analog Input

  // MIDI
  MIDI.begin(MIDI_CHANNEL_OMNI); // Initialize the Midi Library.   //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL to change what channel is listened to
  // OMNI sets it to listen to all channels.
  MIDI.setHandleNoteOn(OnNoteOff); // *** see note with *** above
  // tells the Midi Library which function you want to call when a NOTE ON command is received.
  MIDI.setHandleNoteOff(OnNoteOn); // *** see note with *** above
  MIDI.turnThruOff(); // turn off MIDI thru mode   ////@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL
  MIDI.setHandleControlChange(OnControlChange); //

  MIDI.setHandleProgramChange(OnProgramChange); //
  MIDI.setHandleAfterTouchChannel(OnAfterTouch); //
  MIDI.setHandlePitchBend(OnPitchBend); //

  //25 Acoustic Guitar (nylon) 26 Acoustic Guitar (steel) 27 Electric Guitar (jazz) 28 Electric Guitar (clean) 29 Electric Guitar (muted)
  //30 Overdriven Guitar       31 Distortion Guitar       32 Guitar Harmonics

  for (int i = 1; i <= 16; i++) {  // Have to alternate CC and PC MIDI messages if not only the first CC message is properly transmitted and the rest si a NoteOn somehow
    // it has something to do with the MIDI library, needs to be looked into and fixed. The fast fix is to alternate CC and PC messages.

    MIDI.sendControlChange ( 120, 0, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  //120 is All Sounds OFF
    delay (10);
    //MIDI.sendProgramChange ( 25, i ); //  sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
    MIDI.sendControlChange ( 121, 0, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  //121 is Reset All Controllers
    delay (10);
    //MIDI.sendProgramChange ( 25, i ); //  sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
    MIDI.sendControlChange ( 123, 0, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  //123 is All Notes Off
    delay (10);
    //MIDI.sendProgramChange ( 25, i ); //  sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
    //MIDI.sendControlChange ( 10, 64, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  // 10,64 is the Volume Pan to Centre
    //delay (10);
  }

  // CAPSENSE (Calibration)
  void reset_CS_AutoCal();

  // LEDS
  for (byte i = 0; i < 6; i++) pinAsOutput( led_string_Array[i] ); // same as; pinMode (LED, OUTPUT); but FASTER
  for (byte i = 0; i < 3; i++) LarsonScanner();

  //PIEZO
  piezo_calibration = analogRead(piezo_input) + piezo_treshold;  // value
  piezo_calibration = piezo_calibration >> 3;

}
// ************************************************************************************************************************************************************************
void loop() {  // ***********************************************************************************************************************************************************
  // ************************************************************************* MAIN LOOP ************************************************************************************
  // ************************************************************************************************************************************************************************
  // ************************************************************************************************************************************************************************
  
  // MIDI
  // CAPSENSE (STRINGS)
  // LEDS and MIDI MESSAGES OUT
  // PIEZO (FOR VELOCITY)

  // MIDI
  MIDI.read(); // Continuously check if Midi data has been received.

  note_on_count = 0;  // reset

  for (byte i = 21; i <= 108; i++) {   // piano range is midi note 21 to 108 (A0 to C8)  // guitar range from 52 to 88 (E3 to E6)  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL

    note_on_Array[40] = 1;  // DEBUG ONLY REMOVE AFTER
    note_on_Array[44] = 1;  // DEBUG ONLY REMOVE AFTER
    note_on_Array[47] = 1;  // DEBUG ONLY REMOVE AFTER

    if (note_on_Array[i] == 1) {
      string_Array[note_on_count] = i;
      note_on_count += 1;
      if (note_on_count >= 6) {
        break;
      }
    }
  }

  if (octave_doubling == 1) {   //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL
    if (note_on_count != 0) string_Array[note_on_count]     = string_Array[0] + 12; // adds 1 octave to the 1st string.
    if (note_on_count >  1) string_Array[note_on_count + 1] = string_Array[1] + 12; // adds 1 octave to the 2nd string.
    if (note_on_count >  2) string_Array[note_on_count + 2] = string_Array[2] + 12; // adds 1 octave to the 3rd string.
  }

  // CAPSENSE (STRINGS) *** CAPSENSE: THIS WHAT TAKES THE MOST OF THE TIME IN THE BIG LOOP() about 90% of CPU time ***
  if ( Left_Hand == 0 ) {
    string_total_array [0] =  string_1.capacitiveSensor(10);  //capsense inside brackets is how many samples wh are taking from the sensor, better but slower results if value = 30
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    PiezoSensor();
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    string_total_array [1] =  string_2.capacitiveSensor(10);  //capsense
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    PiezoSensor();
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    string_total_array [2] =  string_3.capacitiveSensor(10);  //capsense
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    PiezoSensor();
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    string_total_array [3] =  string_4.capacitiveSensor(10);  //capsense
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    PiezoSensor();
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    string_total_array [4] =  string_5.capacitiveSensor(10);  //capsense
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    PiezoSensor();
    //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
    string_total_array [5] =  string_6.capacitiveSensor(10);  //capsense
  }
  else if ( Left_Hand == 1 ) {
    string_total_array [5] =  string_1.capacitiveSensor(10);  //capsense inside brackets is how many samples wh are taking from the sensor, better but slower results if value = 30
    PiezoSensor();
    string_total_array [4] =  string_2.capacitiveSensor(10);  //capsense
    PiezoSensor();
    string_total_array [3] =  string_3.capacitiveSensor(10);  //capsense
    PiezoSensor();
    string_total_array [2] =  string_4.capacitiveSensor(10);  //capsense
    PiezoSensor();
    string_total_array [1] =  string_5.capacitiveSensor(10);  //capsense
    PiezoSensor();
    string_total_array [0] =  string_6.capacitiveSensor(10);  //capsense
  }

  checkStrings(); // gets the current state of the strings

  // **************************************************************************************************************************************************************************
  //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
  PiezoSensor();
  //PORTB = PORTB ^ B00000100; // toggles PORT PB2 for scope debugging from HIGHT to LOW and from LOW to HIGH.
  // ****************************************************************************************************************************************************************

  // LEDS and MIDI MESSAGES OUT
  for (byte index = 0; index < 6; index++) {

#ifndef DEBUG
    if (string_Array[index] == 0) {
      digitalLow( led_string_Array [index] );
    }
    else if (string_Array[index] != 0) {
      digitalHigh( led_string_Array [index] );
    }
#endif

#ifdef DEBUG
    if (string_Array[index] == 0) {
      led_string_Array [index] = 0 ;
    }
    else {
      led_string_Array [index] = 1 ;
    }
#endif

    if (piezo_flag == 1) {      // sending midi messages when still pressing the strumpad
      if (string_Array[index] != 0) {
        //if (string_just_released [index] == 1) {
        if (string_just_released [index] == 1 && midi_velocity != 0 ) {
          // *** NoteOn and NoteOff inverted see note with ***
          //MIDI.sendNoteOff (string_Array[index], midi_velocity_zero, midi_channel); // always send a midi note off before a note on
          //MIDI.sendNoteOff (string_Array[index], midi_velocity, midi_channel);  //MIDI.sendNoteOn (string_Array[i], velocity, channel);

          MIDI_MSG3(0x80 | index, string_Array[index], midi_velocity_zero);   // send midi on separate channels, string 1 on channel 1, string 2 on channel 2.....
          MIDI_MSG3(0x90 | index, string_Array[index], midi_velocity); // send midi on separate channels, string 1 on channel 1, string 2 on channel 2....
          //MIDI_MSG3(0x80, string_Array[index], midi_velocity_zero);   // send midi on separate channels, string 1 on channel 1, string 2 on channel 2.....
          //MIDI_MSG3(0x90, string_Array[index], midi_velocity); // send midi on separate channels, string 1 on channel 1, string 2 on channel 2....
        }
      }
    }

    if (piezo_flag == 0) {      // sending midi messages when unpressing the strumpad
      if (string_Array[index] != 0) {
        //if (string_just_released [index] == 1) {
        if (string_just_released [index] == 1 && midi_velocity != 0 ) {
          // *** NoteOn and NoteOff inverted see note with ***
          //MIDI.sendNoteOff (string_Array[index], midi_velocity_zero, midi_channel); // always send a midi note off before a note on
          //MIDI.sendNoteOff (string_Array[index], midi_velocity_max, midi_channel);  //MIDI.sendNoteOn (string_Array[i], velocity, channel);

          MIDI_MSG3(0x80 | index, string_Array[index], midi_velocity_zero);  // send midi on separate channels, string 1 on channel 1, string 2 on channel 2....
          MIDI_MSG3(0x90 | index, string_Array[index], midi_velocity); // send midi on separate channels, string 1 on channel 1, string 2 on channel 2....
          midi_velocity_max = 0;
        }
      }
    }

  }

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  // LARSON SCANNER LEDS & MUTING & RESETTING
  if (string_touched_byte == B00111111) {  // muting when all strings pressed
    digitalHigh( led_string_Array [0] );
    digitalHigh( led_string_Array [1] );
    digitalHigh( led_string_Array [2] );
    digitalHigh( led_string_Array [3] );
    digitalHigh( led_string_Array [4] );
    digitalHigh( led_string_Array [5] );
    for (byte i = 0; i < 6; i++) {
      if ( string_Array[i] != 0 ) {
        // MIDI.sendNoteOff (string_Array[i], midi_velocity_zero, midi_channel); // when touching all Strings at once this will act like MUTE and send NoteOff for all Strings.
        MIDI.sendNoteOff (string_Array[i], midi_velocity_zero, i + 1); // when touching all Strings at once this will act like MUTE and send NoteOff for all Strings.
        delay (10);
      }
    }
    memset(note_on_Array, 0, 127);
    memset(string_Array, 0, 6);
    //LarsonScanner();
    digitalLow( led_string_Array [5] );
    digitalLow( led_string_Array [4] );
    digitalLow( led_string_Array [3] );
    digitalLow( led_string_Array [2] );
    digitalLow( led_string_Array [1] );
    digitalLow( led_string_Array [0] );
  }

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  if (string_touched_byte == B00100001 && reset_timer_started == 0 ) {  // resets when string 1 & 6 pressed passed for more than x milliseconds. Don't need all leds off cause they might be stuck an lit ant that's why we would like to reset.
    start_timer = millis();
    reset_timer_started = 1;
  }
  else if (string_touched_byte != B00100001) {
    reset_timer_started = 0;
  }

  if (string_touched_byte == B00100001 && reset_timer_started == 1) {
    long reset_timer = millis() - start_timer;
    if (reset_timer > 1000) {
      MIDI_ResetAll();
      MIDI_Note_Off_All();
      memset(note_on_Array, 0, 127);
      memset(string_Array, 0, 6);
      LarsonScanner();
      reset_timer = 0;
      reset_timer_started = 0;
    }
  }

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  if (string_touched_byte == B00000001 && timer_started == 0 && string_Array[0] == 0) {  // when pressing string 1 (string0) for few seconds, the octave doubling for the first 3 notes will be cancelled.
    start_timer = millis();
    timer_started = 1;
  }
  else if (string_touched_byte != B00000001) {
    timer_started = 0;
  }
  if (string_touched_byte == B00000001 && timer_started == 1) {
    long reset_timer_1 = millis() - start_timer;
    if (reset_timer_1 > 3000) {

      octave_doubling = !octave_doubling;   //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL

      if ( Left_Hand == 0 ) {
        digitalHigh( led_string_Array [0] );
        delay(100);
        digitalLow( led_string_Array [0] );
        delay(100);
        digitalHigh( led_string_Array [0] );
        delay(100);
        digitalLow( led_string_Array [0] );
        delay(100);
        digitalHigh( led_string_Array [0] );
        delay(100);
        digitalLow( led_string_Array [0] );
      }
      else if ( Left_Hand == 1 ) {
        digitalHigh( led_string_Array [5] );
        delay(100);
        digitalLow( led_string_Array [5] );
        delay(100);
        digitalHigh( led_string_Array [5] );
        delay(100);
        digitalLow( led_string_Array [5] );
        delay(100);
        digitalHigh( led_string_Array [5] );
        delay(100);
        digitalLow( led_string_Array [5] );
      }
      
      reset_timer_1 = 0;
      timer_started = 0;
    }
  }

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  if (string_touched_byte == B00100000 && timer_started_2 == 0 && string_Array[5] == 0) {  // when pressing string 6 (string5) the leds and string are reversed for a left hand player
    start_timer_2 = millis();
    timer_started_2 = 1;
  }
  else if (string_touched_byte != B00100000) {
    timer_started_2 = 0;
  }
  if (string_touched_byte == B00100000 && timer_started_2 == 1) {
    long reset_timer_2 = millis() - start_timer_2;
    if (reset_timer_2 > 3000) {

      // REVERSING THE LED POSITIONS AND CAPACITIVE TOUCH SENSORS FOR A LEFT HAND PLAYER

      Left_Hand = !Left_Hand;

      if ( Left_Hand == 1 ) {
        led_string_Array [0] = 19;
        led_string_Array [1] = 18;
        led_string_Array [2] = 17;
        led_string_Array [3] = 16;
        led_string_Array [4] = 14;
        led_string_Array [5] = 9;

        digitalHigh( led_string_Array [0] );
        delay(200);
        digitalLow( led_string_Array [0] );
        delay(200);
        digitalHigh( led_string_Array [0] );
        delay(200);
        digitalLow( led_string_Array [0] );
        delay(200);
        digitalHigh( led_string_Array [0] );
        delay(200);
        digitalLow( led_string_Array [0] );
      }

      else if ( Left_Hand == 0 ) {
        led_string_Array [0] = 9;
        led_string_Array [1] = 14;
        led_string_Array [2] = 16;
        led_string_Array [3] = 17;
        led_string_Array [4] = 18;
        led_string_Array [5] = 19;

        digitalHigh( led_string_Array [5] );
        delay(200);
        digitalLow( led_string_Array [5] );
        delay(200);
        digitalHigh( led_string_Array [5] );
        delay(200);
        digitalLow( led_string_Array [5] );
        delay(200);
        digitalHigh( led_string_Array [5] );
        delay(200);
        digitalLow( led_string_Array [5] );
      }

      reset_timer_2 = 0;
      timer_started_2 = 0;
    }
  }

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

  // DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG
  /*
     if (string_touched_byte == B00000010 && timer0_started == 0) {    // for Aftertouch
        start_timer0 = millis();
         timer0_started = 1;
      }
     if (string_touched_byte == B00000010 && timer0_started == 1) {
        long reset_timer0 = millis() - start_timer0;
        if (reset_timer0 > 100) {
        MIDI_MSG3( 0xB0, 55, piezo_flag);    // midi message 3 bytes  //string_Array[0]
        MIDI_MSG3( 0xB0, 56, piezo_value);
        MIDI_MSG3( 0xB0, 57, piezo_calibration);
        MIDI_MSG3( 0xB0, 58, piezo_max);
        MIDI_MSG3( 0xB0, 59, piezo_high);
        MIDI_MSG3( 0xB0, 60, midi_velocity);
        MIDI_MSG3( 0xB0, 61, midi_velocity_max);
        //MIDI_MSG2( 0xB0, piezo_value);    // midi message 2 bytes

      /*  Message  Status  Data 1  Data 2
          Note Off              8n  Note Number Velocity
          Note On               9n  Note Number Velocity
          Polyphonic Aftertouch An  Note Number Pressure
          Control Change        Bn  Controller Number Data
          Program Change        Cn  Program Number  Unused
          Channel Aftertouch    Dn  Pressure  Unused
          Pitch Wheel           En  LSB MSB
             Key
             n is the MIDI Channel Number (0-F)
             LSB is the Least Significant Byte
             MSB is the Least Significant Byte
  */
  /*
    }
    }
    else if (string_touched_byte != B00000010) {
     timer0_started = 0;
    }
  */

  //  DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG DEBUG

  /*
    // FOR DEBUG
    byte data_for_debug = readCapacitivePin( ditcapPin );
    byte data_for_debug_last;
    if ( midi_channel_debug == 1) {
    if (control_number_debug == 10) {
      if (data_for_debug != data_for_debug_last) {
         MIDI_MSG(0x90, data_for_debug, 0x45);
      }
    }
    }
  */

}

void checkStrings() //******************************************************************************** checkStrings() ******************************************************
{
  static byte previous_state[6];
  static byte current_state[6];

  for (byte i = 0; i < 6; i++) { // when we start, we clear out the "just" indicators

    string_just_touched[i] = 0;
    string_just_released[i] = 0;

    if (string_total_array [i] > capsense_touched_value)
      current_state[i] = 1;
    else {
      current_state[i] = 0;
    }

    if (current_state[i] != previous_state[i]) {
      if ((string_touched[i] == LOW) && (current_state[i] == HIGH)) {
        // just touched
        string_just_touched[i] = 1;
      }
      else if ((string_touched[i] == HIGH) && (current_state[i] == LOW)) {
        // just released
        string_just_released[i] = 1;
      }
      string_touched[i] = current_state[i];
      bitWrite(string_touched_byte, i, current_state[i]);
    }
    previous_state[i] = current_state[i];   // keep a running tally
  }
}

void OnNoteOn (byte channel, byte pitch, byte velocity) // *********************************************** OnNoteOn *********************************************************
{
  if (velocity != 0) {
    midi_channel = channel;
    note_on_Array[pitch] = 1;
  }
  else if (velocity == 0) {
    note_on_Array[pitch] = 0;
    memset(string_Array, 0, 7); // use this to clear the array instead of 'for' loop
  }
}

void OnNoteOff (byte channel, byte pitch, byte velocity) // *********************************************** OnNoteOff *******************************************************
{
  midi_channel = channel;
  note_on_Array[pitch] = 0;
  memset(string_Array, 0, 7); // use this to clear the array instead of 'for' loop
}

void MIDI_Note_Off_All() {//******************************************************************************* MIDI_Note_Off_All() *********************************************

  for ( byte i = 1; i <= 127; i++ ) {
    for ( byte j = 1; j <= 6; j++ ) {
      MIDI.sendNoteOff (i, 0, j); // send note off for all 6 channels and all notes.
      delay(1);
    }
  }
}

void OnControlChange (byte channel, byte control, byte value) // (channel, control, value) ************************* OnControlChange *************************************************
{
  Serial.write(0xB0);  // only on channel 1
  Serial.write(control);
  Serial.write(value);
  delay (5);
}

void OnProgramChange(byte channel, byte program ) {
  Serial.write(0xC0);  // only on channel 1
  Serial.write(program);
  delay (5);
}

void OnAfterTouch(byte channel, byte pressure ) { // channel Aftertouch ( A0 is polyphonic aftertouch needs note number )
  Serial.write(0xD0);  // only on channel 1
  Serial.write(pressure);
  delay (5);
}

void OnPitchBend(byte channel, int bend) {
  
  byte bendLSB = B01111111 & bend;
  byte bendMSB = bend>>=7;
  Serial.write(0xE0);  // only on channel 1
  //Serial.write(0xB0);  // only on channel 1
  
  if ( bitRead(bend, 13) == 0 ) {
    Serial.write( bendLSB );
    Serial.write( bendMSB+64);
  }
  else {
    //bitClear(bendLSB, 7);
    Serial.write( bendLSB );
    Serial.write( bendMSB-192);
  }

}

void LarsonScanner() // *********************************************************************************** LarsonScanner() *************************************************
{
  digitalHigh( led_string_Array [0] );
  delay(delay_leds);
  digitalHigh( led_string_Array [1] );
  delay(delay_leds);
  digitalHigh( led_string_Array [2] );
  delay(delay_leds);
  digitalLow( led_string_Array [0] );
  delay(delay_leds);
  digitalHigh( led_string_Array [3] );
  delay(delay_leds);
  digitalLow( led_string_Array [1] );
  delay(delay_leds);
  digitalHigh( led_string_Array [4] );
  delay(delay_leds);
  digitalLow( led_string_Array [2] );
  delay(delay_leds);
  digitalHigh( led_string_Array [5] );
  delay(delay_leds);
  digitalLow( led_string_Array [3] );
  delay(delay_leds);

  digitalHigh( led_string_Array [5] );
  delay(delay_leds);
  digitalHigh( led_string_Array [4] );
  delay(delay_leds);
  digitalHigh( led_string_Array [3] );
  delay(delay_leds);
  digitalLow( led_string_Array [5] );
  delay(delay_leds);
  digitalHigh( led_string_Array [2] );
  delay(delay_leds);
  digitalLow( led_string_Array [4] );
  delay(delay_leds);
  digitalHigh( led_string_Array [1] );
  delay(delay_leds);
  digitalLow( led_string_Array [3] );
  delay(delay_leds);
  digitalHigh( led_string_Array [0] );
  delay(delay_leds);
  digitalLow( led_string_Array [2] );
  delay(delay_leds);

  //system exclusive to light up leds on Yamaha EZ AG MIDI guitar (it does not work)
  //MIDI_MSG9(0xF0, 0x43, 0x7F, 0x00, 0x00, 0x03, 0x05, 0x34, 0xF7);
  //delay (1000);
  //MIDI_MSG9(0xF0, 0x43, 0x7F, 0x00, 0x00, 0x04, 0x05, 0x34, 0xF7);
  //delay (1000);
  //MIDI_MSG9(0xF0, 0x43, 0x7F, 0x00, 0x00, 0x03, 0x05, 0x34, 0xF7);
  //delay (1000);

}

void MIDI_ResetAll() //******************************************************************************* MIDI_ResetAll() *****************************************************
{
  for (int i = 1; i <= 16; i++) {
    MIDI.sendControlChange ( 120, 0, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  //120 is All Sounds OFF
    delay (10);
    //MIDI.sendProgramChange ( 25, i );     // sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
    MIDI.sendControlChange ( 121, 0, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  //121 is Reset All Controllers
    delay (10);
    //MIDI.sendProgramChange ( 25, i );     // sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
    MIDI.sendControlChange ( 123, 0, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  //123 is All Notes Off
    delay (10);
    //MIDI.sendProgramChange ( 25, i );     // sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
    //MIDI.sendControlChange ( 10, 64, i ); // sendControlChange (byte  ControlNumber, byte  ControlValue, byte  Channel);  // 10,64 is the Volume Pan to Centre
    //delay (10);
    //MIDI.sendProgramChange ( 25, i );     // sendProgramChange(DataByte inProgramNumber,Channel inChannel);      //25 is Acoustic Guitar
    //delay (10);
  }
}

//  FOR DEBUG
void MIDI_MSG3(byte byte1, byte byte2, byte byte3) {
  Serial.write(byte1);
  Serial.write(byte2);
  Serial.write(byte3);
}
void MIDI_MSG2(byte byte1, byte byte2) {
  Serial.write(byte1);
  Serial.write(byte2);
}
void MIDI_MSG9(byte byte1, byte byte2, byte byte3, byte byte4, byte byte5, byte byte6, byte byte7, byte byte8, byte byte9) {
  Serial.write(byte1);
  Serial.write(byte2);
  Serial.write(byte3);
  Serial.write(byte4);
  Serial.write(byte5);
  Serial.write(byte6);
  Serial.write(byte7);
  Serial.write(byte8);
  Serial.write(byte9);
}
void PiezoSensor() {

  // PIEZO (FOR VELOCITY)
  piezo_value = analogRead(piezo_input); // read analog value of the force sensor; load cell
  piezo_value = piezo_value >> 3; // dividing by 3 to get from 1023 range to 126 range (MIDI range)
  //piezo_value = constrain(piezo_value, piezo_calibration, piezo_max);   // delimits the sensor value

  if (piezo_value > piezo_calibration) {
    if (piezo_flag == 0) {
      piezo_high = 0;
    }
    if (piezo_value > piezo_high) {
      piezo_high = piezo_value;
      midi_velocity = piezo_high;
      midi_velocity = map (midi_velocity, piezo_calibration, piezo_max, 0, 126); // mapping to MIDI Velocity range from 0-126
      midi_velocity_max = midi_velocity;
      piezo_flag = 1;
    }
  }

  if (string_touched_byte == B00000000 && timer_started_3 == 0 ) {
    start_timer_3 = millis();
    timer_started_3 = 1;
  }
  if (string_touched_byte != B00000000) {
    timer_started_3 = 0;
  }
  if ( string_touched_byte == B00000000 && timer_started_3 == 1 ) {
    long reset_timer_3 = millis() - start_timer_3;
    if (reset_timer_3 > 64) {    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ <-------------- CC CONTROL
      piezo_flag = 0;
      midi_velocity = 0;
      reset_timer_3 = 0;
      timer_started_3 = 0;
    }
  }

}


